


; page 0 local var's (declared in bios temp. work area)
_P0BTMP:	.SECTION page0, ref_only, offset bwrktmp	; DP Tmp. BIOS
DSKTMP_START	.EQU	$

drive		.DB		; ata #0 or ata #1 device
lba		DS	3	; 24 bit sector address
secnum		.DB		; sector(s) count # (if 0 -> 256 sec.)
seccnt		.DB		; copy of secnum
ifrbit		.DB		; bit to test on VIA3 IFR

ataop		.DB		; ata operation flag
				; <7>=0->read, 1->write
				; <6>=1 compare (ignored in dma mode)
bufp		LP		; in/out buffer long pointer
tlp		LP		; start buffer pointer

xbuf		.DW		; x-mem buffer # ($0B40..$0FFF)
				; dma buffer # ($0000..$7FFF)
xbnk		.DB		; starting x-mem bank
xsave		.DB		; save x-mem setting
nlba		.DW		; total sector's count #
ncnt		.DW		; dma words count #
tmp		.DB		; temp
ataofs		.DB		; temp: ata offset address
wtmp		.DW		; temp. word
mbrsgn		.DW		; mbr signature
mbrfg		.DW		; mbr first partition flag
tmpy		.DB

ATATMP_SIZ	.EQU	($-ATATMP_START)
	.ENDS


CLSDMA		.EQU	$100	; dma buffer # for cluster cache

; device identifiction data loaded in dma buffer # $100, 
; devoted to cluster cache and limited to 64 sectors
;

	stz	bufp		; init dma buffer pointer
	stz	bufp+1
	lda	#DMABNK
	sta	bufp+2
	lda	!VIA3+VIAPRB	; set dma bank
	and	#11111000B	; mask off 3 lower's bits   
	ora	#>CLSDMA	; high byte of buffer # select the bank
	sta	!VIA3+VIAPRB	; set bank

	lda	>IFRTST,x
	sta	ifrbit		; save right IFR bit to test on VIA3
	lda	>ATANDX,x
	tax			; X = ata index
	stz	!ATADEV,x	; select device #0
	nop
?rdy:	bit	!ATAALTST,x	: wait device ready
	bmi	?rdy
	bvc	?rdy
	nop
	stz	!ATACTRL,x	; enable ata device to assert interrupt
	nop
	nop
	lda	ifrbit	
	sta	!VIA3+VIAIFR	; clear CA1/CA2 flag in VIA3 IFR
	lda	#IDENTDEV	; "identify device" command
	sta	!ATACMD,x	; store command

	; this command get data in "pio read" mode
	; should wait for ata interrupt assertion
	;
	lda	ifrbit		; CA1 or CA2 flag
?w1:	bit	!VIA3+VIAIFR	; test CA1/CB1 transition
	beq	?w1		; wait interrupt assertion from ata device
	sta	!VIA3+VIAIFR	; clear CA1 or CA2 interrupt flag
?w2:	lda	!ATAST,x	; now wait BUSY bit=0
	bmi	?w2
	bit	#ATADRQ		; ready to read a data block?
	bne	?rdb		; yes, read data block
	bit	#ATADFB+ATAERRB
	bne	?chk		; error -- stop
	bra	?w2		; some CF need time to set DRQ 	

	; now cpu can read data block (256 words)
	;
?rdb:	php			; save I flag
	sei			; disable interrupt
	ldy	#0		; buffer index
	CPU16			; X,Y 16 bit - XH,YH cleared
?get:	lda	>ATADATA,x	; latch data
	lda	!ATAPORT,x	; read latched data
	sta	[bufp],y	; store word
	iny
	iny
	cpy	#$0200			
	bcc	?get		; loop 512 bytes	
	CPU08
	plp			; restore I flag
	lda	!ATAST,x	; read status reg.
	bit	#ATABSY+ATADRQ	; check anomalies
	beq	?chk		; BSY & DRQ flag's must be cleared
	jsr	devres		; software reset ata device
	lda	#EDSK_RST	; reset error
	sec
?rts:	rts
?chk:	jsr	chkstat		; check error's
	bcs	?rts

	; check signature of identification record (if enabled)
	; compute a checksum of the entire record
	;
	ldy	#0
	tya
	INDEX16
?lp:	clc			; loop checksum computation
	adc	[bufp],y
	iny
	cpy	#$200
	bcc	?lp
	xba			; B = checksum
	dey
	dey
	lda	[bufp],y
	INDEX08	
	cmp	#$A5		; valid signature checksum?
	bne	?go		; no -- assume data ok and skip checksum test
	xba			; checksum vill be zero
	beq	?go		; checksum ok
	lda	#EDISK_IDCKS	; identify checksum erro
	sec
	rts	
	
	; now get last user sector number, description strings
	; and device type
	;
?go:	ldy	#10*2		; offset 'serial number' string
	ldx	#10		; words length
	jsr	?swp		; adjust string
	ldy	#23*2		; offset 'firmware revision' string
	ldx	#4		; words length
	jsr	?swp		; adjust string
	ldy	#27*2		; offset 'model name' string
	ldx	#20		; words length
	jsr	?swp		; adjust string
	ldx	#10*2		; pointer to 'serial number' string
	ldy	#(10*2)+(10*2)-1	; pointer to end of string
	jsr	?stz		; terminate string
	ldx	#27*2		; pointer to 'model name' string
	ldy	#(27*2)+(20*2)-1	; pointer to end of string
	jsr	?stz		; terminate string

	; copy strings
	ldx	drive
	lda	DSKMODEL,x	; get 'model' string address
	sta	tlp
	lda	DSKMODELH,x	
	sta	tlp+1
	lda	#^DISKDEVSTR	; bank
	sta	tlp+2
	jsr	?cpy		; move string
	ldx	drive
	lda	DSKSER,x	; get 'serial' string address
	sta	tlp
	lda	DSKSERH,x	
	sta	tlp+1
	jsr	?cpy		; move string
	
	ldx	#23*2		; offset 'firmware revision' string
	ldy	#(23*2)+(4*2)-1	; pointer to end of string
	jsr	?stz		; terminate string
	lda	DSKREV,x	; get 'firmware revision' string address
	sta	tlp
	lda	DSKREVH,x	
	sta	tlp+1
	jsr	?cpy		; move string

	ldy	#60*2		; word 60/61: last user sector #
	ldx	wtmp
	ACC16
	lda	[bufp],y
	sta	lba
	sta	atasec,x	; store max. user sectors
	iny
	iny
	lda	[bufp],y
	sta	lba+2
	sta	atasec+2,x
	lda	[bufp]		; C.F. identification
	ldx	drive
	ldy	tmpy		; hard disk flag
	cmp	#$848A		; classic word 0 for C.F.
	beq	?06		; is C.F.
	cmp	#$044A		; alternate word 0 for CF
	beq	?06		; is C.F.
	sty	atadev,x	; is H.D.
?06:	ACC08
	lda	atadev,x
	ora	#$20		; flag identify ok
	sta	atadev,x
	clc			; no error
?10:	rts

	; swap low byte with high byte in string
	; Y = string offset
	; X = words string length
	;
?swp:	ACC16
?swpl:	lda	[bufp],y
	xba
	sta	[bufp],y
	iny
	iny
	dex
	bne	?swpl
	ACC08
	rts

	; terminate serial string and model string with null
	; Y=end of string
	; X=start of string
	;
?stz:	stx	tmp	
?stzl:	lda	[bufp],y
	cmp	#' '
	bne	?stzx
	dey
	cpy	tmp
	bcs	?stzl
?stzx:	iny
	lda	#0
	sta	[bufp],y
?stxe:	rts

	; copy string from bufp (offset Y) to tlp
	;
?cpy:	ldx	#0		; destination index
?cpyl:	lda	[bufp],y
	iny
	sty	tmp
	txy
	sta	[tlp],y
	cmp	#0
	beq	?stxe
	iny
	tyx
	ldy	tmp
	bra	?cpyl
	
; test ata status register for error condition
; in:	A = status
;	X = ata # index
; out:	CF = 0 if no error
;	CF = 1 if error & A = error code
;
chkstat:
	bit	#ATADFB		; device fault bit ?
	beq	?chk1		; no
	lda	#EDISK_FAULT	; yes
	bra	?err		; error
?chk1:	bit	#ATAERRB	; error bit ?
	beq	?ok		; no... all seem good
	lda	!ATAERROR,x	; read error register
	asl	a		; BBK/ICRC bit <7> error?
	bcc	?unc		; no, check UNC bit <6>
	lda	#EDISK_BBK	; bad block/crc error
	bra	?err
?unc:	asl	a		; UNC bit <6> error?
	bcc	?idnf		; no, check IDNF bit <4>
	lda	#EDISK_UNC	; uncorrectable error
	bra	?err
?idnf:	asl	a
	asl	a		; IDNF bit <4> error?
	bcc	?abrt		; no, check ABRT bit <2>
	lda	#EDISK_SEC	; bad sector number
	bra	?err
?abrt:	asl	a
	asl	a		; ABRT bit <2> error?
	bcc	?amnf		; no, check AMNF bit <0> error
	lda	#EDISK_ABRT	; abort
	bra	?err
?amnf:	asl	a
	asl	a
	bcc	?unk		; unknow error
	lda	#EDISK_GEN	; general error
	bra	?err
?unk:	lda	#EDISK_UNKN
?err:	sec
	rts
?ok:	clc			; no error in statu reg.	
	rts

; dma setup for a transfer cycle on channel 1/2
; in:	drive	= 0 or 1 (ata #0 or ata #1 device)
;	diskop	= current operation on ata device: 0->read, 1->write
;	ncnt	= words count # to transfer - 1
;	dmabuf	= dma buffer # ($0000..$07FF)
;	lba[0..2] = 24 bits starting lba
;	seccnt	= sector(s) count
;
dmaset:
	; dma buffer is organized in 8 x 128Kb banks or 8 x 64Kw banks
	; PB0..PB2 of VIA3 set MA16..MA18 lines of 512Kw ram (DMA access)
	;
	lda	.ABS.DMA0SR	; clear status flag
	lda	!VIA3+VIAPRB	; set dma bank
	and	#11101000B	; mask off 3 lower's bits, clear PB4 (ata #0)   
	ora	dmabuf+1	; high byte of buffer # select the bank
	ora	#00100000B	; set /FDC line high (dma/ata access)
	ldx	drive
	beq	?via		; select ata 0
	ora	#00010000B	; select ata #1 (PB4 high)
?via:	sta	!VIA3+VIAPRB	; set bank & select ata #
	lda	>DMAREQ,x
	sta	dmareq		; check dma request line on VIA3 PRA
	lda	>IFRTST,x
	sta	ifrbit		; save right IFR bit to test on VIA3
	lda	>DMACHNL,x
	sta	dmachnl		; dma channel
	tay
	asl	a		; dma status register mask
	sta	dmast
	tya
	ora	#$04
	sta	!DMA0WMSKB	; mask off bit channel 1/2
	txy			; save drive #
	ldx	diskop		; 0 -> read, 1 -> write
	lda	>DMAMOD,x	; transfer mode
	ora	dmachnl		; concatenate channel #
	sta	!DMA0MODE	; set DMA transfer mode
	tyx			; X = drive #
	lda	>DMANDX,x	; get address/counter index
	sta	!DMA0WCLRFF	; clear F/F
	sta	dmandx
	tax			; X = index
	stz	!DMAC0,x	; buffer low address (always 0, sec-aligned) 
	lda	dmabuf		; high mem address
	sta	!DMAC0,x	; buffer high address
	inx			; counter register index
	sta	!DMA0WCLRFF	; clear F/F
	lda	ncnt		; low count
	sta	!DMAC0,x	; store low count
	lda	ncnt+1		; high count
	sta	!DMAC0,x	; store high count
	nop
	sta	!DMA0WCLRFF	; clear F/F	
	lda	dmachnl
	sta	!DMA0WMSKB	; un-mask bit channel 1/2
	lda	#00000100B	; VIA0 PA3 set dma direction
	ldx	diskop
	bne	?wr		; clear direction (write to ata)
	tsb	VIA0+VIAPRANH	; set direction (write to mem)
	bra	?nxt
?wr:	trb	VIA0+VIAPRANH	; clear direction
?nxt:	lda	>ATACMD,x	; ata command for read/write
	tyx			; X = drive #
	tay			; Y = ata command
	lda	>ATANDX
	tax			; X = ata index

	; now set ata register's for current operation (read/write)
	;
	lda	#$E0		; select device #0, set lba limited to 24 bits
	sta	!ATADEV,x	; set device register
	nop
	nop
	nop
	nop
?w1:	bit	!ATAALTST,x	: wait device ready
	bmi	?w1
	bvc	?w1
	stz	!ATACTRL,x	; enable interrupt assertion
	lda	seccnt		; store sectors count
	sta	!ATASCTCNT,x
	nop
	nop
?w2:	bit	!ATAALTST,x	; wait device ready
	bmi	?w2
	bvc	?w2
	lda	lba		; store starting sector
	sta	!ATALBAL,x
	nop
	nop
?w3:	bit	!ATAALTST,x	; wait device ready
	bmi	?w3
	bvc	?w3
	lda	lba+1
	sta	!ATALBAM,x
	nop
	nop
?w4:	bit	!ATAALTST,x	; wait device ready
	bmi	?w4
	bvc	?w4
	lda	lba+2
	sta	!ATALBAH,x
	nop
	nop
?w5:	bit	!ATAALTST,x	; wait device ready
	bmi	?w5
	bvc	?w5
	lda	ifrbit	
	sta	!VIA3+VIAIFR	; clear CA1 or CA2 flag in IFR
	tya			; ata command
	sta	!ATACMD,x	; store command
	nop
	nop
	nop
	nop
	
	; now wait for dma request line assertion from ata device , or
	; for an error condition
	;
	lda	!ATAALTST,x	; dummy ead
?w6:	lda	!ATAST,x	; wait
	and	#ATABSY+ATADRQ	; if busy & drq bit's both 0...
	beq	?chk		; ... an error occurred
	lda	!VIA3+VIAPRANH	; check the right dma request line
	and	dmareq		; dma request?
	beq	?w6		; no

	; ata device ready to transfer data, so disable internal cpu bus
	; and enable dma bus
	;
	lda	#$02		; enable dma & internal dma bus
	trb	VIA0+VIAPRANH
	
	; when transfer is complete, ata device assert an interrupt
	; we wait interrupt assertion within an assigned timeout
	;
	jsr	wataint		; return CF=1 if timeout
	lda	#$02		; disable dma & re-enable cpu bus
	tsb	VIA0+VIAPRANH
	bcc	?rds		; ok, no timeout: read status
	jsr	devres		; software reset ata device
	lda	#EDSK_RES	; reset error
	bra	?err
?rds:	lda	>ATAST,x	; read status register & clear interrupt	
?chk:	bit	#ATADFB		; device fault bit ?
	beq	?chk1		; no
	lda	#EDISK_FAULT	; yes
	bra	?err		; error
?chk1:	bit	#ATAERRB	; error bit ?
	beq	?chk2		; no... all seem good
	lda	!ATAERROR,x	; read error register
	asl	a		; BBK/ICRC bit <7> error?
	bcc	?unc		; no, check UNC bit <6>
	lda	#EDISK_BBK	; bad block/crc error
	bra	?err
?unc:	asl	a		; UNC bit <6> error?
	bcc	?idnf		; no, check IDNF bit <4>
	lda	#EDISK_UNC	; uncorrectable error
	bra	?err
?idnf:	asl	a
	asl	a		; IDNF bit <4> error?
	bcc	?abrt		; no, check ABRT bit <2>
	lda	#EDISK_SEC	; bad sector number
	bra	?err
?abrt:	asl	a
	asl	a		; ABRT bit <2> error?
	bcc	?amnf		; no, check AMNF bit <0> error
	lda	#EDISK_ABRT	; abort
	bra	?err
?amnf:	asl	a
	asl	a
	bcc	?uer		; unknow error
	lda	#EDISK_GEN	; general error
	bra	?err
?uer:	lda	#EDISK_UNKN
	bra	?err
?chk2:	lda	.ABS.DMA0SR	; clear dma status flag
	sta	!DMA0WCLRFF	; clear F/F
	and	dmast		; channel 1 or 2 reached TC?
	beq	?loss		; no, dma cycle ended before to reach TC
	ldy	dmandx
	lda	DMAC0,y		; read low count residue
	xba
	lda	DMAC0,y		; read high count residue
	xba
	ACC16			; must be C = $FFFF
	inc	a
	ACC08	
	bne	?loss
	clc			; no error	
	rts
?loss:	lda	#EDISK_DLOSS	; data loss
?err:	sec			; error flag
	ldy	.ABS.DMA0SR	; clear dma status flag
	rts


; wait interrupt assertion from ata device within a timeout
wataint:
	lda	#$20		; set T2 count PB6 pulse (1ms)
	tsb	VIA0+VIAACR	
	lda	#<INTTMO	; interrupt timeout
	sta	!VIA0+VIAT2CL
	lda	#>INTTMO
	sta	!VIA0+VIAT2CH
?wa:	lda	ifrbit		; flag bit for test CA1/CA2 
	bit	!VIA3+VIAIFR
	bne	?ok		; interrupt assertion (exit with CF=0)
	lda	#T2IFRB
	bit	!VIA0+VIAIFR
	beq	?wa		; wait for INTTMO ms
	lda	ifrbit		; flag bit for test CA1/CA2 
	bit	!VIA3+VIAIFR
	bne	?ok		; interrupt assertion
	sec			; timeout
	rts
?ok:	sta	!VIA3+VIAIFR	; clear interrupt flag
	clc
	rts

; wait for busy flag low on ata device within BUSYTMO timeout
; in:	X = ata # index
;	NF=0 if status bit busy low
;	NF=1 if status bit busy high or if timeout
; use:	A
wbusyl:
	lda	#$20		; set T2 count PB6 pulse (1ms)
	tsb	VIA0+VIAACR	
	lda	#<BUSYTMO	; timeout status bit busy
	sta	!VIA0+VIAT2CL
	lda	#>BUSYTMO
	sta	!VIA0+VIAT2CH
?wl:	lda	!ATAST,x	; read status
	bpl	?end		; OK - busy -> L, return NF = 0
	TASKSW			; switch task while wait
	lda	#T2IFRB
	bit	VIA0+VIAIFR	; test timeout
	beq	?wl		; loop
	lda	!ATAST,x	; read status - return NF = busy bit
?end:	rts


; check devices on ata bus
; in:	X=device ata #
?atachk:	
	stx	drive
	stz	diskstat,x	; clear device flag
	jsr	?bmsg		; print start msg
	lda	>ATANDX,x
	stx	atandx
	stz	!ATADEV,x	; store dev. register
	jsr	wbusyl		; wait for busy flag low
	bmi	?pe1		; no device
	asl	a		; check DRDY flag
	bcc	?pe1		; not ready
	jsr	?chksgn		; check device signature
	bcs	?pe2		; device is not HD/CF
	jsr	ident		; identify device
	bcs	?pe3		; error (A = error code)
	bit	BiosEnt
	bvc	?skp		; skip
	jsr	showdisk	; print disk data
?skp:	;jsr	devres	
	;jsr	chkmbr		; load&check MBR	
	clc			; no error	
	rts

?pe1:	; print 'device not found'
	SCNPRINT
	.DB	'device not found.', 13, 0
	sec
	rts

?pe2:	; print 'not H.D. nor C.F. device'
	SCNPRINT
	.DB	'not H.D. nor C.F. device.', 13, 0
	sec
	rts

?pe3:	; fail to identify device
	pha			; error code
	phk
	pea	#!?fmte  
	lda	#5
	pha
	BPRINTF
	sec
	rts

?fmte:
	.DB	'fail to identify device (error %bu).', 13, 0

; check device signature after reset
; in:	drive = ata # device
;	atandx = ata # index
; out:	CF=0 if found device
;	CF=1 if not device or not HD/CF
;
?chksgn:
	ldy	atandx
	ldx	#3		; test signature device HD/CF
?sgnl:	lda	>ATASGN,x
	cmp	!ATASCTCNT,y	; test signature
	bne	?nohd		; no HD/CF
	iny
	dex
	bpl	?sgnl
	lda	!ATASCTCNT,y	; device #
	and	#$10		; mask dev bit
	bne	?nohd		; will be 0
	iny
	lda	!ATASCTCNT,y	; status reg.
	and	#ATADRDY	; DRDY bit will be set
	beq	?nohd		; device not found or not HD/CF
	lda	#$C0		; flag device
	ldx	drive		; for now force C.F type
	sta	diskstat,x	; found device on ata # 
	clc
	rts
?nohd:	sec
	rts

	; print check message at boot
	; in:	drive=ata # device
?bmsg:	bit	BiosEnt
	bvc	?bmsgx		; skip
	ldx	drive
	phx
	phk
	pea	#!?bstr
	lda	#5
	pha
	BPRINTF
?bmsgx:	rts

?bstr:	.DB	'ata   #%bu...', 0

; show disk information at boot
; in:	drive = ata/usb device
;	lba[0..3] = total sector's count #
;
showdisk:
	ACC16CLC		; compute rounded size in Mb
	lda	lba+2
	ldx	#11		; divide by 2048 (11 shift)...
?shr:	lsr	a		; ... and get rounded size in Mb
	ror	lba
	dex
	bne	?shr
	sta	lba+2		; lba[0..3] = size in Mb
	ACC08
	ldx	drive
	clc
	txa
	adc	#'C'		; get drive letter
	sta	ldrv
	lda	>DSKMODEL,x	; get address of model string
	sta	bufp
	lda	>DSKMODELH,x
	sta	bufp+1
	lda	#^DISKDEVSTR	; bank
	sta	bufp+2		; bufp long pointer to model string
	lda	diskstat,x	; bit <6> = 1 if usb device
	tay
	asl	a
	sta	tmp		; for easy test
	xba
	tya
	and	#00000011B	; get bus #
	sta	tmp2
	xba
	asl	a		; CF = 1 if usb device
	bcc	?cf		; Compact Flash or Hard Disk
	
	; print usb drive data
	pei	(lba+2)		; size
	pei	(lba)
	lda	bufp+2
	pha			; address of model string
	pei	(bufp)
	lda	ldrv
	pha			; drive letter
	lda	tmp2
	pha			; usb bus #
	phk			; address of format string
	pea	#?usbf
	lda	#13		; arguments size
	pha
	BPRINTF
	rts
	
	; print ata drive data
?cf:	asl	a
	ACC16
	lda	#!?hds		; hard disk
	bcc	?nxt
	lda	#!?cfs		; compact flash
?nxt:	sta	tlp		; address of device type string
	ACC08
	pei	(lba+2)		; size
	pei	(lba)
	lda	bufp+2
	pha			; address of model string
	pei	(bufp)
	lda	ldrv
	pha			; drive letter
	phk			; device type string	
	pei	(tlp)
	phk			; address of format string
	pea	#?ataf
	lda	#15		; arguments size
	pha
	BPRINTF
	rts

; format string for usb drive
?usbf:	.DB	'usb   #%bu:  usb drive %c:  %-42.41s %,7u Mb', 13, 0

?hds:	.DB	'Hard Disk', 0
?cfs:	.DB	'C. Flash ', 0

; format string for ata drive
?ataf:	.DB	'%s %c  %-42.41s %,7u Mb', 13, 0


;--------------------------------------------------------------------------
; tables
;---------------------------------------------------------------------------

; dma channel related to ata drive #
DMACHNL:
	.DB	$01, $02

; DMAREQ bit (PA7, PA6) related to ata drive #
DMAREQ:
	.DB	$80, $40

; dma transfer mode related to current disk operation (0 -> read, 1 -> write)
DMAMOD:
	.DB	WRITETRASF	; write transfer: read ATA, write MEM
	.DB	READTRASF	; read  transfer: read MEM, write ATA

; dma index to access the right address/counter register's 
DMANDX:
	.DB	DMAADDR1, DMAADDR2

; for test VIA3 IFR (interrupt from ata device)
IFRTST:
	.DB	CA1IFRB, CA2IFRB

; command to ata device for read/write operation
ATACMD:
	.DB	READDMA		; read sector(s) command
	.DB	WRITEDMA	; write sector(s) command

; index to access the right ata register's
ATANDX:
	.DB	0, ATAOFS

; string's address (drive # indexed)
DSKMODEL:
	.DB	<_atamod0, <_atamod1, <_usbdsc0, <_usbdsc1

DSKMODELH:
	.DB	>_atamod0, >_atamod1, >_usbdsc0, >_usbdsc1
	
DSKSER:
	.DB	<_ataser0, <_ataser1

DSKSERH:
	.DB	>_ataser0, >_ataser1
	
DSKREV:
	.DB	<_atarev0, <_atarev1

DSKREVH:
	.DB	>_atarev0, >_atarev1

; HD/CF signature (in reverse order)	
ATASGN:
	.DB	$00, $00, $01, $01
	