;;
;; Copyright (c) 2013 Marco Granati <mg@unet.bz>
;;
;; Permission to use, copy, modify, and distribute this software for any
;; purpose with or without fee is hereby granted, provided that the above
;; copyright notice and this permission notice appear in all copies.
;;
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
;; WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
;; MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
;; ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
;; ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
;; OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

;; bios 65C816 version v 1.0

;; timer.asm
;; system timer managment

	.INCLUDE inc\global.inc
	.INCLUDE inc\dirp00.inc

	.CODEF8
	.EXTERN LF8Tst

	.LONGA	off
	.LONGI	off

;---------------------------------------------------------------------------
; system call interface
;---------------------------------------------------------------------------

sys_tasksw:
	
	.PUBLIC sys_tasksw

	ACC16			; retrieve subfunction number
	lda	STKPCL,s	; pointer to byte after signature
	sta	COPPtr
	inc	a		; update return address
	sta	STKPCL,s
	ACC08			; A,M -> 8 bit
	lda	STKPBR,s	; bank where was executed cop instruction
	sta	COPPtr+2	
	lda	[COPPtr]	; byte after signature
	beq	?80
	;bcc	?02		; ok
	sec
	lda	#EINV		; error
	rtl

?80:	jsr	LF8Tst
	clc
	rtl


sys_mkfs:
	.PUBLIC sys_mkfs

	clc
	rtl
