
freecnt		.DW		; free cluster's count
nextfree	.DW		; next free cluster
maxcls		.DW		; last usable cluster+1
fatsize		.DW		; FAT16 fat table size
clscnt		.DW		; cluster's count #

ldrv		.DB		; temp.: logical drive
ldttmp		.DB		; temp.: LDT pointer
pdev		.DB		; temp.: phisycal drive

; mbrld - load & check fixed disk mbr
;
; in:	ldrv = logical drive
;	pdev = phsycal drive
;	ldttmp = pointer to LDT
;
; out:	CF = 1 if error, A = error code
;	LDT updated
;
;-----
mbrld:
;-----
	stz	tlp		; dma buffer
	stz	tlp+1
	lda	#DMABNK
	sta	tlp+2
	lda	pdev		; phisycal device #
	tay			; Y = phisycal drive
	asl	a		; x 4
	asl	a
	tax
	ACC16
	lda	!diskmax,x
	sta	maxsec
	lda	!diskmax+2,x
	sta	maxsec+2
	ACC08
	phy			; drive
	pea	#0		; load sector #0
	pea	#0
	lda	#1		; load 1 sector
	pha
	pea	#CLSBUF		; dma buffer #
	DISKRD			; read dik sector
	bcs	??		; error (Y = error code)
	
	lda	#00001000	; set mbr loaded 
	sta	tmp
	CPU16
	ldy	#$01C2		; partition type pointer
	lda	[tlp],y
	sta	<mbrtype	; partition type (low byte)
	ldy	#$01C6		; partition start pointer
	lda	[tlp],y
	sta	hidsec		; partition start
	iny
	iny
	lda	[tlp],y
	sta	hidsec+2
	iny
	iny
	lda	[tlp],y		; partition size in sector's
	sta	totsec
	iny
	iny
	lda	[tlp],y
	sta	totsec+2
	ldy	#$01BE		; partition flag pointer
	lda	[tlp],y
	sta	<mbrflag	; partition flag (low byte)
	ldy	#$01FE		; signature pointer
	lda	[tlp],y
	cmp	#$AA55
	CPU08
	bne	?20		; invalid mbr signature
	lda	#$18		; add valid mbr signature flag
	sta	tmp
	lda	<mbrflag	; must be $80 or 0
	beq	?vv
	bpl	?20		; first partition invalid	
?vv:	lda	#$1C		; add active partition flag
	sta	tmp
	ldy	ldttmp		; LDT pointer
	lda	<mbrtype	; update partition type
	sta	!P0LDT+ldt_ptype,y
	ACC16
	lda	totsec		; update partition size
	sta	!P0LDT+ldt_psize,y
	lda	totsec+2
	sta	!P0LDT+ldt_psize+2,y
	lda	hidsec		; update partition start
	sta	!P0LDT+ldt_pstart,y
	lda	hidsec+2
	sta	!P0LDT+ldt_pstart+2,y
	xba			; A = high lba of partition start	
	bne	?20		; must be 0
	cpy	#$06		; just FAT16 type
	beq	?10
	cpy	#$04		; FAT 16 for disk less than 32Mb
	beq	?10
	cpy	#$0E
	bne	?20
?10:	
	lda	#$1D		; add valid partition type
	sta	tmp
?20:	ldx	drive		; update device flag
	lda	atadev,x
	ora	tmp
	sta	atadev,x
	clc
?30:	rts
